LeetCode Next Greater Element I 问题

You are given two arrays (without duplicates) nums1 and nums2 where nums1’s elements are subset of nums2. Find all the next greater numbers for nums1's elements in the corresponding places of nums2.

The Next Greater Number of a number x in nums1 is the first greater number to its right in nums2. If it does not exist, output -1 for this number.

Example 1:

Input: nums1 = [4,1,2], nums2 = [1,3,4,2].
Output: [-1,3,-1]
Explanation:
    For number 4 in the first array, you cannot find the next greater number for it in the second array, so output -1.
    For number 1 in the first array, the next greater number for it in the second array is 3.
    For number 2 in the first array, there is no next greater number for it in the second array, so output -1.

Example 2:

Input: nums1 = [2,4], nums2 = [1,2,3,4].
Output: [3,-1]
Explanation:
    For number 2 in the first array, the next greater number for it in the second array is 3.
    For number 4 in the first array, there is no next greater number for it in the second array, so output -1.

Note:

  1. All elements in nums1 and nums2 are unique.
  2. The length of both nums1 and nums2 would not exceed 1000.

题目的大意是:给两个数组nums1和nums2,而nums1是nums2的子集,返回的数组是:nums1中当前数字在nums2中相同位置的右侧第一个大于nums1中当前数字的所有数字

我的求解比较暴力,快O(n³)了,执行时间17ms

public static int[] nextGreaterElement(int[] nums1, int[] nums2) {
        int[] result = new int[nums1.length];
        for (int i=0;i<nums1.length;i++){
            for (int j=0;j<nums2.length;j++){
                if(nums1[i]==nums2[j]){
                    for (int k=j;k<nums2.length;k++){
                        if (nums2[k]>nums2[j]&&k<nums2.length){
                            result[i] = nums2[k];
                            break;
                        }else{
                            result[i] = -1;
                        }
                    }
                }
            }
        }
        return result;
    }

思路是找到nums1中当前数字在nums2中的位置j,从这个位置开始再继续遍历,找到比nums[i]大的数字就放到result中,然后break,找不到就是-1


看人家大神的做法,其实人家是用一个map来替代了我最里层的for循环
public static int[] nextGreaterElement(int[] nums1, int[] nums2) {
        Map<Integer, Integer> m = new HashMap<>();
        // go through each element in nums and set its location in HashMap
        for(int i =0;i<nums2.length;++i)
            m.put(nums2[i],i); //since every element is unique, there is no need (getOrDefault)

        //scan each element in the first array
        for(int i=0;i<nums1.length;++i)
        {
            int minIndex =-1;  //initially, set the finding index to be -1
            int index = m.get(nums1[i]); //findout the corresponding index in the second (nums) array.
            while(++index < nums2.length)
            {
                if(nums2[index]>nums1[i])
                {
                    minIndex =index;
                    break;
                }
            }
            if(minIndex ==-1) nums1[i] = -1;
            else nums1[i] = nums2[minIndex];
        }
        return nums1;
    }






评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值